#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t; cin >> t;
    int n,k; cin >> n >> k;
    vector<int> a(n);
    for(int i=0; i<n; i++)cin >> a[i];
    sort(a.begin(),a.end());
    int p=0;
    for(int i=0; i<n; i++){
        if(a[i]>=p)p++;
        else p--;
    }
    if(p==k){
        cout << "DA\n";
        for(int x : a)cout << x << ' ';
    }
    else {
        while(next_permutation(a.begin(),a.end())){
            for(int i=0; i<n; i++){
                if(a[i]>=p)p++;
                else p--;
            }
            if(p==k){
                cout << "DA\n";
                for(int x : a)cout << x << ' ';
            }
        }
    }
    return 0;
}